from flask import Flask,render_template,request
import datetime
from math import pi
app = Flask(__name__)

@app.route('/')
def index():
    p = "mikaël"
    n = "le mentec"
    date = datetime.datetime.now()
    heure = date.hour
    minute = date.minute
    seconde = date.second
    r = 2
    aire = pi*r**2
    return render_template("index.html",prenom = p, nom = n, heure = heure, minute=minute, seconde=seconde, rayon = r, aire = aire)


@app.route('/contact')
def presentation():
    date_naissance = datetime.datetime(1981, 9, 21)
    duree = datetime.datetime.now() - date_naissance
    jours = duree.days
    return render_template("contact.html",naissance = date_naissance ,jours=jours)


@app.route('/loisir')
def loisir():
    message = "<h1> Présentation de la course à pied </h1>"
    message += "<h2> Pourquoi la course à pied </h2>"
    message += "<p> La nature, l'exercice physique sont des plaisirs à savourer ! </p>"
    return message

@app.route('/resultat',methods = ['GET','POST'])
def salutation():
    if request.method == 'GET':
        prenom_visiteur = request.args['prenom']
        nom_visiteur = request.args['nom']
    elif request.method == 'POST':
        prenom_visiteur = request.form['prenom']
        nom_visiteur = request.form['nom']
    return render_template('resultat.html',prenom=prenom_visiteur,nom=nom_visiteur)

@app.route('/cesar')
def texte_a_coder():
    return render_template('cesar.html')


def cesar(texte, cle):
    """
    Fonction de codage par décalage (césar)
    Entrées : une chaine de caractères et un entier
    Sortie : une chaine de caractère
    """
    texte_code = ""
    for char in texte:
        if char.isalpha(): #si le caractère est une lettre on décale
            nouvelIndice = ord(char) + cle
            #Pour rester dans l'aplphabet, on décale de 26 en arrière si besoin
            if ord(char) <= ord('z') < nouvelIndice or ord(char) <= ord('Z') < nouvelIndice: 
                nouvelIndice -= 26
            lettrefinale = chr(nouvelIndice)
            texte_code += lettrefinale
        else: #si le caractère n'est pas une lettre, on n'y touche pas
            texte_code += char
    return texte_code

# Tests
assert cesar('abcd',1) == 'bcde'
assert cesar('z',1) == 'a'
assert cesar('Z',2) == 'B'
assert cesar('Bonjour tout le MONDE !',18) == 'Tgfbgmj lgml dw EGFVW !'


@app.route('/codage',methods = ['POST'])
def codage():
    texte_original = request.form['texte']
    cle = int(request.form['cle'])
    texte_apres_codage = cesar(texte_original,cle)    
    return render_template('codage.html',texte_original=texte_original,texte_apres_codage=texte_apres_codage)


if __name__ == '__main__':
    app.run(debug=True)